#pragma once
/* 
   #pragma once is the better #ifndef-#define-#endif.
   Virtually all compilers support it, it prevents symbol clashes
   and saves you lots of tedious typing. :) 
 */

struct critical_section_t
{
#pragma message("Implementation missing")
};


/* Double-pointer (**) for cs.
   A common C-pattern to let the called
   function allocate and initialize a structure.
   The passed pointer then points to a pointer of that structure.
   (see main.c for usage)

   Your Delete function must thus free the allocated memory.
*/
void My_InitializeCriticalSection(struct critical_section_t **cs);

void My_DeleteCriticalSection(struct critical_section_t *cs);

void My_EnterCriticalSection(int id, struct critical_section_t *cs);

void My_LeaveCriticalSection(int id, struct critical_section_t *cs);
